Attribute VB_Name = "Module1"
Option Explicit

Private Const C As Single = 0.5

Public pl   As Single
Public ph   As Single
Public R    As Single

Dim ql      As Single
Dim qr      As Single

Dim vcl As Single
Dim vcr As Single
Dim il  As Single
Dim ir  As Single
Dim ull As Single
Dim ulh As Single
Dim url As Single
Dim urh As Single
Dim dt  As Single



Public Const WAVE_FORMAT_PCM = 1
Public Const WAVE_MAPPER = -1&

Public Const CALLBACK_WINDOW = &H10000
Public Const GWL_WNDPROC = (-4)

Public Const MM_WOM_OPEN = &H3BB
Public Const MM_WOM_DONE = &H3BD
Public Const MM_WOM_CLOSE = &H3BC

Public Const Buffer_Size = 512
Public Const Buffers = 4


Public Type WaveHeader
    sChunkID        As String * 4
    ChunkSize       As Long
    sFormat         As String * 4
    Subchunk1ID     As String * 4
    Subchunk1Size   As Long
    AudioFormat     As Integer
    NumChannels     As Integer
    SampleRate      As Long
    ByteRate        As Long
    BlockAlign      As Integer
    BitsPerSample   As Integer
    Subchunk2ID     As String * 4
    Subchunk2Size   As Long
End Type

Public Type WAVEHDR
    lpData As Long
    dwBufferLength As Long
    dwBytesRecorded As Long
    dwUser As Long
    dwFlags As Long
    dwLoops As Long
    lpNext As Long
    Reserved As Long
End Type

Public Type WAVEFORMATEX
    wFormatTag As Integer
    nChannels As Integer
    nSamplesPerSec As Long
    nAvgBytesPerSec As Long
    nBlockAlign As Integer
    wBitsPerSample As Integer
    cbSize As Integer
End Type


Public Declare Function waveOutOpen Lib "winmm.dll" (lphWaveOut As Long, ByVal uDeviceID As Long, lpFormat As WAVEFORMATEX, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Public Declare Function waveOutClose Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Public Declare Function waveOutReset Lib "winmm.dll" (ByVal hWaveOut As Long) As Long

Public Declare Function waveOutWrite Lib "winmm.dll" (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long

Public Declare Function waveOutPrepareHeader Lib "winmm.dll" (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Public Declare Function waveOutUnprepareHeader Lib "winmm.dll" (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long

Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByRef lParam As WAVEHDR) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)


Public lpPrevFunc   As Long

Public wh                   As WaveHeader

Public Headers(Buffers - 1) As WAVEHDR
Public Buffer_Data(Buffer_Size * 4 - 1, Buffers - 1) As Integer

Public DatiL                As Long
Public DatiB()              As Byte

Public DatiS                As Long
Public DatiSx()             As Integer
Public DatiDx()             As Integer

Public lsx          As Long
Public ldx          As Long
Public lsx2         As Long
Public ldx2         As Long

Public wave_handle  As Long

Public curPos       As Long
Public curSamp      As Long


'WindowProcedure
Public Function waveOut_Func_Subclassed(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByRef curr_header As WAVEHDR) As Long
    Select Case uMsg
        Case MM_WOM_OPEN
            Form1.SB1.Panels(1).Text = "Riproduzione in corso..."
        Case MM_WOM_DONE
            FillBuffer curr_header.dwUser
            waveOutWrite wave_handle, Headers(curr_header.dwUser), Len(Headers(curr_header.dwUser))
        Case MM_WOM_CLOSE
            Form1.SB1.Panels(1).Text = "Riproduzione interrotta"
    End Select
    waveOut_Func_Subclassed = CallWindowProc(lpPrevFunc, hwnd, uMsg, wParam, curr_header)
End Function

Public Sub FillBuffer(Index As Long)
On Error GoTo errore
Dim lx  As Long
Dim x   As Long
Dim p   As Long
Dim sx  As Long
Dim dx  As Long
Dim sx2 As Long
Dim dx2 As Long
    dt = 1 / wh.SampleRate
    Form1.Picture1.Cls
    For x = 0 To Buffer_Size - 1
        'SX
        vcl = ql / C
        il = (DatiSx(curSamp) - vcl) / R
        ql = ql + il * dt
        ull = vcl
        ulh = DatiSx(curSamp) - vcl
        'DX
        vcr = qr / C
        ir = (DatiDx(curSamp) - vcr) / R
        qr = qr + ir * dt
        url = vcr
        urh = DatiDx(curSamp) - vcr
        'MIX
        Buffer_Data(x * 2, Index) = ull * pl + ulh * ph
        Buffer_Data(x * 2 + 1, Index) = url * pl + urh * ph
        'Disegna
'        If x Mod 4 = 0 Then
            sx = 32767& - DatiSx(curSamp)
            dx = 98301 - DatiDx(curSamp)
            sx2 = 32767& - Buffer_Data(x * 2, Index)
            dx2 = 98301 - Buffer_Data(x * 2 + 1, Index)
            Form1.Picture1.Line (x, sx)-(lx, lsx), vbGreen
            Form1.Picture1.Line (x, sx2)-(lx, lsx2), vbRed
            Form1.Picture1.Line (x, dx)-(lx, ldx), vbGreen
            Form1.Picture1.Line (x, dx2)-(lx, ldx2), vbRed
            lsx = sx
            ldx = dx
            lsx2 = sx2
            ldx2 = dx2
            lx = x
'        End If
        curSamp = curSamp + 1
    Next x
    curPos = (curPos + Headers(Index).dwBufferLength) Mod DatiL
    curSamp = curSamp Mod DatiS
Exit Sub
errore:
    'Reset
    ql = 0
    qr = 0
End Sub

Public Sub Perform_waveOutOpen()
Dim wav_format As WAVEFORMATEX
    wav_format.wFormatTag = WAVE_FORMAT_PCM
    wav_format.nBlockAlign = 4
    wav_format.nAvgBytesPerSec = 4 * wh.SampleRate
    wav_format.nChannels = 2
    wav_format.nSamplesPerSec = wh.SampleRate
    wav_format.wBitsPerSample = 16
    wav_format.cbSize = Len(wav_format)
    waveOutOpen wave_handle, WAVE_MAPPER, wav_format, Form1.hwnd, True, CALLBACK_WINDOW
End Sub

Public Sub Prepare_Headers()
Dim i   As Byte
    For i = 0 To Buffers - 1
        Headers(i).lpData = VarPtr(Buffer_Data(0, i))
        Headers(i).dwBufferLength = Buffer_Size * 4
        Headers(i).dwUser = i
        Headers(i).dwLoops = 0
        waveOutPrepareHeader wave_handle, Headers(i), Len(Headers(i))
    Next i
End Sub

Public Sub Begin_waveOut()
Dim i   As Byte
    For i = 0 To Buffers - 1
        waveOutWrite wave_handle, Headers(i), Len(Headers(i))
    Next i
End Sub

Public Sub UnPrepare_Headers()
Dim i   As Byte
    For i = 0 To Buffers - 1
        waveOutUnprepareHeader wave_handle, Headers(i), Len(Headers(i))
    Next i
End Sub

Public Sub Perform_WaveOutClose()
    waveOutClose wave_handle
    wave_handle = 0
End Sub

Public Function Avvia() As Boolean
    If wave_handle <> 0 Then
        Avvia = False
        Exit Function
    End If
    Perform_waveOutOpen
    Prepare_Headers
    Begin_waveOut
    Avvia = True
End Function

Public Function Ferma() As Boolean
    If wave_handle = 0 Then
        Ferma = False
        Exit Function
    End If
    waveOutReset wave_handle
    UnPrepare_Headers
    Perform_WaveOutClose
    Ferma = True
End Function
